package org.processmining.acceptingpetrinetredundantplacesreductor.algorithms;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetFactory;
import org.processmining.acceptingpetrinetredundantplacesreductor.parameters.RemoveStructuralRedundantPlacesParameters;
import org.processmining.algorithms.BerthelotAlgorithm;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.parameters.BerthelotParameters;

public class RemoveStructuralRedundantPlacesAlgorithm {

	public AcceptingPetriNet apply(PluginContext context, AcceptingPetriNet net,
			RemoveStructuralRedundantPlacesParameters parameters) {
		AcceptingPetriNet reducedNet = AcceptingPetriNetFactory.createAcceptingPetriNet();
		BerthelotParameters berthelotParameters = new BerthelotParameters();
		berthelotParameters.setInitialMarking(net.getInitialMarking());
		berthelotParameters.setFinalMarkings(net.getFinalMarkings());
		BerthelotAlgorithm berthelotAlgorithm = new BerthelotAlgorithm();
		Petrinet pn = berthelotAlgorithm.apply(null, net.getNet(), berthelotParameters);
		reducedNet.init(pn);
		reducedNet.setInitialMarking(berthelotParameters.getInitialBerthelotMarking());
		reducedNet.setFinalMarkings(berthelotParameters.getFinalBerthelotMarkings());
		return reducedNet;
	}
}
