package org.processmining.acceptingpetrinetredundantplacesreductor.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinetredundantplacesreductor.parameters.RemoveStructuralRedundantPlacesParameters;
import org.processmining.framework.connections.impl.AbstractConnection;

public class RemoveStructuralRedundantPlacesConnection extends AbstractConnection {

	public final static String NET = "Net";
	public final static String REDUCEDNET = "ReducedNet";

	private RemoveStructuralRedundantPlacesParameters parameters;

	public RemoveStructuralRedundantPlacesConnection(AcceptingPetriNet net, AcceptingPetriNet reducedNet,
			RemoveStructuralRedundantPlacesParameters parameters) {
		super("Remove Structural Redundant Places Connection");
		put(NET, net);
		put(REDUCEDNET, reducedNet);
		this.parameters = new RemoveStructuralRedundantPlacesParameters(parameters);
	}

	public RemoveStructuralRedundantPlacesParameters getParameters() {
		return parameters;
	}
}
